<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
    <title>Sensor Calibration</title>

    <!-- <link rel='stylesheet' type="text/css" href='../css/meti_merged.css'> -->

    <script src='../js/jquery.min.js'></script>
    <!-- <script src='../js/meti_utils.js'></script> -->

    <style>
        .container {
            visibility: hidden;
        }
    </style>

</head>

<body>
    <div id="page_load_wait">Please wait...</div> 
    <div w3-include-html="meti_bst.html"></div>

    <div class="container">
        <div class="row">
            <main role="main" class="col-sm-12 col-md-8 col-lg-6 pt-2">
                <h5 class="p-1">Sensor Calibration Values</h5>
                <form id="formID">
                    <div class="border border-primary p-2">
                        <div class="sensor_settings">
                            <!-- Zero Value -->
                            <div class="form-group p-0 m-1 row">
                                <label class="col-5" for="sel_zero">Zero (4 mA)</label>
                                <input type="text" id="sel_zero" name="sel_zero"
                                    class="col-4 form-control form-control-sm"
                                    data-validation-engine="validate[required] custom[integer], min[-9999], max[9999]">
                                <button type="button" id="button_zero"
                                    class="col btn btn-sm btn-danger ml-3">Calibrate</button>
                            </div>

                            <!-- Span Value -->
                            <div class="form-group p-0 m-1 row">
                                <label class="col-5" for="sel_span">Span (20 mA)</label>
                                <input type="text" id="sel_span" name="sel_span"
                                    class="col-4 form-control form-control-sm"
                                    data-validation-engine="validate[required] custom[integer], min[-9999], max[9999]">
                                <button type="button" id="button_span"
                                    class="col btn btn-sm btn-danger ml-3">Calibrate</button>
                            </div>
                        </div>

                        <div class="col-sm-12 form-group row mt-4 mb-1">
                            <button type="button" id="button_cancel"
                                class="btn btn-warning col ml-4 mr-4">Cancel</button>
                            <button type="button" id="button_save" class="btn btn-success col ml-4 mr-4">Save</button>
                        </div>
                    </div>
                </form>
            </main>
        </div>
</body>

<footer class="page-footer font-small blue pt-4">
    <div w3-include-html="footer.html"></div>
</footer>

</html>

<script>

    // $(document).ready(function () {
    //     // setTimeout(function () {
    //     $.ajax({
    //         url: "../css/meti_merged.css",
    //         success: function (data) {
    //             $("<style></style>").appendTo("head").html(data);

    //             $.when($.getScript('../js/meti_merged.js'),
    //                 $.getScript('../js/meti_utils.js'),
    //             ).then(function () {
    //                 console.log('the css and js loaded successfully and are both ready');
    //                 w3IncludeHTML();
    //                 test();
    //             }, function () {
    //                 console.log('an error occurred somewhere');
    //             });
    //         }
    //     });
    //     // }, 750);
    // });

    $(document).ready(function () {
        // setTimeout(function () {
            $.ajax({
                url: "../css/meti_merged.css",
                success: function (data) {
                    $("<style></style>").appendTo("head").html(data);
                    
                    $.getScript("../js/meti_merged.js")
                        .done(function (script, textStatus) {
                            $.getScript("../js/meti_utils.js")
                                .done(function (script, textStatus) {
                                    // All done execute file...
                                    w3IncludeHTML();
                                    test();
                                })
                                .fail(function (jqxhr, settings, exception) {
                                    console.log("Unable to load meti_utils.js");
                                });
                        })
                        .fail(function (jqxhr, settings, exception) {
                            $("div.log").text("Unable to load meti_merged.js");
                        });
                }
            })
        // }, 750);
    });

    function test() {
        var ZERO_CAL_MIN = 370;
        var ZERO_CAL_MAX = 430;
        var SPAN_CAL_MIN = 1900;
        var SPAN_CAL_MAX = 2100;
        $("#page_load_wait").remove();
        $(".container").css("visibility","visible");
        // display all items
        // document.getElementsByTagName("container")[0].style.visibility = "visible";
        
        // setupSelects();

        // function setupSelects() {
        // 	//keep alive
        // 	dataArray = [0, 1, 2, 3]
        // 	for (idx = 0; idx < dataArray.length; idx++) {
        // 		var opt = $('<option></option>')
        // 			.val(dataArray[idx])
        // 			.addClass('dropdown-item')
        // 			.addClass('dd-item')
        // 			.text(dataArray[idx]);

        // 		$("#sel_decimals").append(opt);
        // 	}
        // }

        $("#button_save").on("click", function () {
            if ($("#formID").validationEngine('validate')) {

                var sel_zero = $("#sel_zero").val();
                var sel_span = $("#sel_span").val();

                if (sel_zero <= ZERO_CAL_MIN || sel_zero >= ZERO_CAL_MAX) {
                    alert("Invalid Zero calibration... \n\n Please retry after setting proper input current..")
                } else if (sel_span <= SPAN_CAL_MIN || sel_span >= SPAN_CAL_MAX) {
                    alert("Invalid Span calibration... \n\n Please retry after setting proper input current..")
                } else {
                    var r = confirm("Save Sensor Calibration configuration?");
                    if (r == true) {
                        save_config();
                    }
                }
            }
        });

        $("#button_cancel").on("click", function () {
            document.location.href = "index.html";
        });

        function load_form_data() {
            $("#packet_version").val(g_sensorScaling_db.pkt_ver);
            $("#sel_zero").val(g_sensorScaling_db.calibratedZero);
            $("#sel_span").val(g_sensorScaling_db.calibratedSpan);
        }

        function save_config() {
            var debug = 0;

            g_sensorScaling_db.calibratedZero = $("#sel_zero").val();
            g_sensorScaling_db.calibratedSpan = $("#sel_span").val();

            var url = "/updateSensorScaling";
            var type = 'POST';
            var data = {
                sensorScaling: JSON.stringify(g_sensorScaling_db)
            };

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    if (debug == 1) {
                        console.log(response);
                    }
                    else {
                        // console.log(js_response);
                        var result = response.result;

                        if (result == 1) {
                            alert(response.message);
                        }
                        else if (result == 0) {
                            alert(response.message);
                        }
                    }
                },
                error: function (jqXHR, exception, response) {
                    alert('POST Error!');
                }
            });
        }

        $("#button_zero").on("click", function () {
            var obj = $(this);
            enableDisable(obj, false);

            setTimeout(function () {
                calibrate_values(obj);  //zero calibration is 1
            }, 4000);
        });

        $("#button_span").on("click", function () {
            var obj = $(this);
            enableDisable(obj, false);

            setTimeout(function () {
                calibrate_values(obj); //span calibration is 2
            }, 4000);
        });

        function enableDisable(obj, isEnable) {
            if (isEnable == false) {
                $(obj).removeClass('btn-danger btn-primary btn-success')
                    .addClass('btn-primary')
                    .html('Wait...')

                $(".btn").attr("disabled", "disabled");
            } else {
                $(obj).removeClass('btn-danger btn-primary btn-success')
                    .html('Calibrate');

                sel_zero = $("#sel_zero").val();
                sel_span = $("#sel_span").val();

                if (sel_zero <= ZERO_CAL_MIN || sel_zero >= ZERO_CAL_MAX) {
                    $("#button_zero").addClass("btn-danger");
                } else {
                    $("#button_zero").addClass("btn-success");
                }

                if (sel_span <= SPAN_CAL_MIN || sel_span >= SPAN_CAL_MAX) {
                    $("#button_span").addClass("btn-danger");
                } else {
                    $("#button_span").addClass("btn-success");
                }

                $(".btn").removeAttr("disabled");
            }
        }

        function calibrate_values(obj) {
            var debug = 0;

            var url = "/calibrateSensor";
            var type = 'POST';
            var data = {
                calibrateId: 0
            };

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    if (debug == 1) {
                        console.log(response);
                    }
                    else {
                        // console.log(js_response);
                        var result = response.result;

                        if (result == 1) {
                            if ($(obj).attr('id') == "button_zero") {
                                //Zero calibration
                                $("#sel_zero").val(response.message);
                            } else {
                                //Span calibration
                                $("#sel_span").val(response.message);
                            }
                        }
                        else if (result == 0) {
                            alert(response.message);
                        }
                    }
                    enableDisable(obj, true);
                },
                error: function (jqXHR, exception, response) {
                    alert('POST Error!');
                    enableDisable(obj, true);
                }
            });
        }

        function noSensorData(response) {
            console.log("POST Error...")
        }

        function updateDevicesParams(response) {
            $("#sel_clientId").val(response.dev_id);
        }
        //********* Call all start up functions after this line *******//

        setTimeout(function () {
            getDeviceParams(updateDevicesParams, noSensorData);
        }, 500);

        setTimeout(function () {
            readSensorScalingFromFS(load_form_data);
        }, 750);

        $("#formID").validationEngine();

    }
</script>